'#########################################################################
'### Messgerteuhr
'### (CC) by-nc-sa Joachim Fossie Br Reiter (bascom@fakedomain.de) 2014
'### Uhr mit Darstellung auf Messgerten mit mA-Eingang
'### Werte fr Vorwiderstnde
'###   1mA  3,9k ist mit etwas Reserve
'###   5mA  780R
'###  10mA  390R
'### Tastaturroutinen von Peter Dannegger portiert auf BASCOM
'###
'### 05.09.12 Korrektur fr 24Stunden Uhrskala
'### 02.09.14 Korrektur automatische Sommer-Winterzeitumstellung
'###          Jahreseingabe hinzugefgt. Wird als Schritt 7 mit der
'###          Tagesscala gemacht, also 2001-2031. Braucht man frs
'###          Schaltjahr
'#########################################################################

$version 0 , 4 , 14
Const Quarz = 8000000
$regfile = "m8def.dat"
$crystal = Quarz
$baud = 9600
Baud = 9600
Const Timer2_reload = Int(256 -(quarz / 1024 * 0.01))
$framesize = 64
$hwstack = 64
$swstack = 64

Const Debugging = 0

' GANZ WICHTIG
Config Submode = New
' Dann binden wir mal die Lib ein fr Sommer/Winterzeitumstellung
$include "Datumskram.inc"

$lib "ds1307clock.lib"                                      ' modified lib
'$lib "EURODATETIME.LBX"

'##############################################################################
'###### Liste mit Werten fr Anzeigemaximas
'##############################################################################
$eeprom
Data 0 , 0 , 0
Data &HB2 , &HB2 , &HB2 , &HB2 , &HB2 , &HB2 , &HB2
$data

Const Ein = 0
Const Aus = 1

'###### Ausgnge fr die Instrumente initialisieren
Instr_port Alias Portb
Config Instr_port = Output
Mon_out Alias Instr_port.0
Day_out Alias Instr_port.1
Wday_out Alias Instr_port.2
Std_out Alias Instr_port.3
Min_out Alias Instr_port.4
Sek_out Alias Instr_port.5


'###### Die Tastereingnge initialisieren
'Variablen fr die Entprell-Routine
Key_port Alias Portc
Key_pins Alias Pinc
Config Key_port = Input
Key_port = &B00001111
Dim Key_i As Byte
Dim Key_ct0 As Byte
Dim Key_ct1 As Byte
Dim Key_state As Byte
Dim Key_press As Byte
Dim Key_rpt_count As Byte
Dim Key_rpt As Byte
Dim Key_temp As Byte
Dim Taste As Byte
Up_key Alias 0
Down_key Alias 1
Enter_key Alias 2
Key_mask Alias &B00000111
Key_repeat_mask Alias &B00000111
Const Key_repeat_start = 100                                ' After 1000ms
Const Key_repeat_next = 20                                  ' Every 200ms

Smooth Alias Pinc.3
Calibrate Alias Pind.6
Config Calibrate = Input
Setclock Alias Pind.7
Config Setclock = Input
Portd = 255

Dim Ep_max(7) As Eram Byte At &H03
Dim Akt_array(7) As Byte
Dim New_array(7) As Byte
Dim Max_array(7) As Byte
Dim Akt_time(7) As Byte
Dim Calc_array(7) As Byte
Dim Text_array(7) As String * 9
Dim Arraycount As Byte
Dim Akt_datum As Long
Dim Status As Byte

Dim _wday As Byte
Dim Old_sec As Byte
Dim Disp_wert As Single
Dim Sek As Integer
Dim Temp As Byte

Dim Timercount As Byte
Dim Timercount1 As Integer

Dim Progstate As Byte

Config Date = Dmy , Separator = .                           ' ANSI-Format
Config Clock = User
Const Ds1307w = &B11010000
Const Ds1307r = &B11010001
Config Sda = Portc.4
Config Scl = Portc.5


Config Timer0 = Timer , Prescale = 1                        ' 8Bit-Timer parametrieren
On Timer0 Timer0_int
Enable Timer0

Config Timer2 = Timer , Prescale = 1024
On Timer2 Timer2_int                                        'Interrupt Service Routine anspringen
Timer2 = Timer2_reload
Enable Timer2

Enable Interrupts                                           ' und die Interrupts aktivieren

Text_array(1) = "Monat"
Text_array(2) = "Tag"
Text_array(3) = "Wochentag"
Text_array(4) = "Stunde"
Text_array(5) = "Minute"
Text_array(6) = "Sekunde"
Text_array(7) = "Jahr"

'#########################################################################
Init:
    #if Debugging
        Print "INIT"
    #endif
    ' Init Eingnge
    Key_ct0 = 255
    Key_ct1 = Key_ct0
    Key_state = 0
    Key_press = 0

    'Aus EEPROM Maximalwert fr Anzeige lesen
    For Arraycount = 1 To 7
        Max_array(arraycount) = Ep_max(arraycount)
    Next Arraycount

    ' Faktoren fr die Anzeige einstellen
    Calc_array(1) = 12                                      ' Monat
    Calc_array(2) = 31                                      ' Tag
    Calc_array(3) = 6                                       ' Wochentag
    Calc_array(4) = 24                                      ' Stunden
    Calc_array(5) = 60                                      ' Minuten
    Calc_array(6) = 60                                      ' Sekunden
    Calc_array(7) = 31                                      ' Jahr 2001-2031

    Gosub Getdatetime
    Reset _sec.7
    I2cstart                                                ' Generate start code
    I2cwbyte Ds1307w                                        ' send address
    I2cwbyte 0                                              ' starting address in 1307
    I2cwbyte _sec                                           ' Send Data to SECONDS

    Old_sec = 200

    ' Uhrzeit lesen wenn gltig (RAM=J)
    I2cstart                                                ' Generate start code
    I2cwbyte Ds1307w                                        ' send address
    I2cwbyte 10                                             ' starting address in 1307
    I2cstart                                                ' Generate start code
    I2cwbyte Ds1307r                                        ' send address
    I2crbyte Temp , Nack                                    ' Read Kennbyte
    If Temp <> 64 Then                                      ' 64 = Daten i.O.
        I2cstart                                            ' Generate start code
        I2cwbyte Ds1307w                                    ' send address
        I2cwbyte 10                                         ' starting address in 1307
        I2cwbyte 64                                         ' Kennbyte schreiben
        I2cstop
        _sec = 0
        _min = 0
        _hour = 7
        _wday = 5
        _day = 5
        _month = 1
        _year = 14
        Gosub Setdatetime
    End If
    Call Checksommerzeit(0 , Status)                        ' und prfen
    Progstate = 0

'#########################################################################
Main:
  ' ###### Normalbetrieb
  If Calibrate = Aus And Setclock = Aus Then
    Gosub Getdatetime
    If Progstate > 0 Then
      Reset _sec.7
      I2cstart                                              ' Generate start code
      I2cwbyte Ds1307w                                      ' send address
      I2cwbyte 0                                            ' starting address in 1307
      I2cwbyte _sec                                         ' Send Data to SECONDS
      'Aus EEPROM Maximalwert fr Anzeige lesen
      For Arraycount = 1 To 6
        Max_array(arraycount) = Ep_max(arraycount)
      Next Arraycount

      Progstate = 0
    End If

    If _sec <> Old_sec Then
      Akt_time(1) = _month
      Akt_time(2) = _day
      Akt_time(3) = _wday
      Akt_time(4) = _hour
      Akt_time(5) = _min
      Akt_time(6) = _sec
      For Arraycount = 1 To 6
        Disp_wert = Max_array(arraycount) / Calc_array(arraycount)
        Akt_array(arraycount) = Disp_wert * Akt_time(arraycount)
      Next Arraycount
      Sek = Akt_array(6)

      Timercount1 = 0

      Old_sec = _sec
      If _sec = 0 And _min = 0 Then                         ' Neue Stunde
        Call Checksommerzeit(1 , Status)                    ' und prfen
      End If

      #if Debugging
        Print _wday ; "  " ; _day ; "." ; _month ; "." ; _year ; "  " ; Time$
      #endif
    End If

    Disp_wert = Timercount1 / 3125
    Disp_wert = Max_array(6) * Disp_wert
    Disp_wert = Disp_wert / 600
    Disp_wert = Sek + Disp_wert
    If Smooth = Ein Then Disp_wert = Sek
    Akt_array(6) = Disp_wert

  ' #### Programmiermodus
  Else
    Select Case Progstate
    Case 0
      Gosub All_instr_off
      If Setclock = Ein Then
        Gosub Getdatetime
        Akt_time(1) = _month
        Akt_time(2) = _day
        Akt_time(3) = _wday
        Akt_time(4) = _hour
        Akt_time(5) = _min
        Akt_time(6) = _sec
        Akt_time(7) = _year

        For Temp = 1 To 7
          New_array(temp) = Akt_time(temp)
        Next Temp
        #if Debugging
          Print "Uhr stellen"
        #endif
      Else
        For Temp = 1 To 7
          New_array(temp) = Ep_max(temp)
        Next Temp
        #if Debugging
          Print "Skalen kalibrieren"
        #endif

      End If
      Incr Progstate
      #if Debugging
        Print Text_array(progstate) ; "   " ; New_array(progstate)
      #endif

    Case 1 To 7
      Disp_wert = Max_array(progstate) / Calc_array(progstate)
      If Calibrate = Ein Then Disp_wert = 1
      Temp = Progstate
      If Progstate = 7 Then Temp = 2
      Akt_array(temp) = Disp_wert * New_array(progstate)

    End Select

    Gosub Check_key
    If Taste.up_key = 1 Then Incr New_array(progstate)
    If Taste.down_key = 1 Then Decr New_array(progstate)

    If Setclock = Ein Then
      Select Case Progstate
      Case 1
        If New_array(progstate) > 12 Then New_array(progstate) = 1
        If New_array(progstate) < 1 Then New_array(progstate) = 12
      Case 2
        If New_array(progstate) > 31 Then New_array(progstate) = 1
        If New_array(progstate) < 1 Then New_array(progstate) = 31
      Case 3
        If New_array(progstate) = 255 Then New_array(progstate) = 6
        If New_array(progstate) > 6 Then New_array(progstate) = 0
      Case 4
        If New_array(progstate) = 255 Then New_array(progstate) = 24
        If New_array(progstate) > 24 Then New_array(progstate) = 0
      Case 5 To 6
        If New_array(progstate) = 255 Then New_array(progstate) = 59
        If New_array(progstate) > 59 Then New_array(progstate) = 0
      Case 7
        If New_array(progstate) > 31 Then New_array(progstate) = 1
        If New_array(progstate) < 1 Then New_array(progstate) = 31
      End Select
    End If

    If Taste.enter_key = 1 Then
      Temp = Progstate
      If Progstate = 7 Then Temp = 2
      Akt_array(temp) = 0
      If Setclock = Ein Then
        Akt_time(progstate) = New_array(progstate)
        Gosub Setdatetime_array
      Else
        Ep_max(progstate) = New_array(progstate)
      End If

      Incr Progstate
      If Calibrate = Ein Then
          If Progstate = 7 Then
            Ep_max(7) = New_array(6)
            Progstate = 1
          End If
      Else
          If Progstate = 8 Then Progstate = 1
      End If
    End If

    #if Debugging
        If Taste <> 0 Print Text_array(progstate) ; "   " ; New_array(progstate)
    #endif
  End If
Goto Main


'#########################################################################

Timer0_int:
    Incr Timercount
    If Timercount = 0 Then
        Mon_out = Aus
        Day_out = Aus
        Wday_out = Aus
        Std_out = Aus
        Min_out = Aus
        Sek_out = Aus
    End If

    If Timercount > Akt_array(1) Then Mon_out = Ein
    If Timercount > Akt_array(2) Then Day_out = Ein
    If Timercount > Akt_array(3) Then Wday_out = Ein
    If Timercount > Akt_array(4) Then Std_out = Ein
    If Timercount > Akt_array(5) Then Min_out = Ein
    If Timercount > Akt_array(6) Then Sek_out = Ein
    Incr Timercount1
Return


Timer2_int:
  Timer2 = Timer2_reload
  Key_i = Key_pins
  Key_i = Not Key_i
  Key_i = Key_i And Key_mask
  Key_i = Key_i Xor Key_state
  Key_ct0 = Key_ct0 And Key_i
  Key_ct1 = Key_ct1 And Key_i
  Key_ct0 = Not Key_ct0
  Key_ct1 = Key_ct1 Xor Key_ct0
  Key_i = Key_i And Key_ct0
  Key_i = Key_i And Key_ct1
  Key_state = Key_state Xor Key_i
  Key_i = Key_i And Key_state
  Key_press = Key_press Or Key_i

  Key_temp = Key_state And Key_repeat_mask
  If Key_temp = 0 Then Key_rpt_count = Key_repeat_start

  Decr Key_rpt_count
  If Key_rpt_count = 0 Then
    Key_rpt_count = Key_repeat_next
    Key_temp = Key_state And Key_repeat_mask
    Key_rpt = Key_rpt Or Key_temp
  End If
Return




'#########################################################################
'# Datum und Uhrzeit aus RTC auslesen
Getdatetime:
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' start address in 1307

  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307r                                          ' send address
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                                       ' MINUTES
  I2crbyte _hour , Ack                                      ' Hours
  I2crbyte _wday , Ack                                      ' Day of Week
  I2crbyte _day , Ack                                       ' Day of Month
  I2crbyte _month , Ack                                     ' Month of Year
  I2crbyte _year , Nack                                     ' Year
  I2cstop

  _sec = Makedec(_sec)
  _min = Makedec(_min)
  _hour = Makedec(_hour)
  _day = Makedec(_day)
'  Decr _day
  Decr _wday
  _month = Makedec(_month)
  _year = Makedec(_year)
Return



'#########################################################################
'# Datum in RTC schreiben
Setdatetime:
  _sec = Makebcd(_sec)
  _min = Makebcd(_min)
  _hour = Makebcd(_hour)
'  Incr _day
  Incr _wday
  _day = Makebcd(_day)
  _month = Makebcd(_month)
  _year = Makebcd(_year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cwbyte _wday                                            ' Send Data to day
  I2cwbyte _day                                             ' Send Data to day
  I2cwbyte _month                                           ' month
  I2cwbyte _year                                            ' year
  I2cstop
Return

'#########################################################################
'# Daten aus Array in RTC schreiben
Setdatetime_array:
  _sec = Makebcd(new_array(6))
  _min = Makebcd(new_array(5))
  _hour = Makebcd(new_array(4))
  _wday = New_array(3)
  Incr _wday
  _day = Makebcd(new_array(2))
  _month = Makebcd(new_array(1))
  _year = Makebcd(new_array(7))
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cwbyte _wday                                            ' Send Data to day
  I2cwbyte _day                                             ' Send Data to day
  I2cwbyte _month                                           ' month
  I2cwbyte _year                                            ' year
  I2cstop
Return


All_instr_off:
  For Arraycount = 1 To 7
    Akt_array(arraycount) = 0
  Next Arraycount
Return

Check_key:
  ' ### Erst mal die Eingnge und Taster checken
  Disable Timer2                                            'Timerinterrupt deaktivieren
  Taste = 0
  ' Eingnge bearbeiten wenn was passiert ist
  Taste = Key_press
  Key_press = 0
  Taste = Taste Or Key_rpt
  Key_rpt = 0
  Enable Timer2                                             'Interrupt wieder aktivieren
Return